//******************************************************************************
//!
//! @file $Id: main.c 2100 2008-09-25 13:01:59Z raubree $
//!
//! Copyright (c) 2008 Atmel.
//!
//! @brief 啔: ͖JԂɊÂ܂B
//!
//! @todo
//! @bug
//******************************************************************************

/* 쌠 (c) 2008, Atmel Corporation S\ς݁B
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 * Ȃł傤B
 */

//_____ ݸٰ _______________________________________________________________

#include "config.h"
#include "usi_twi_slave.h"
#include "bldc.h"
#include "TinyX61_macros.h"
#include "ushell_task.h"

/*
 * ̉p𓮂O:
 * CKDIV8˭ނ֎~Ă̂mɂĂB
 * ۯƂPLLݒ肵ĂB
 */

volatile motorControlFlags_t mcFastFlags;
volatile U8 ControlMode;
volatile U16 SpeedMeasure;
volatile U16 timer_value;
volatile U16 new_measured_speed;
volatile Bool is_speed_to_read=FALSE;

// TWI呕uʐMɑ΂USI]û߂USI޼ϐ
Bool is_data_to_send=0;
Bool is_data_received=0;
unsigned char data_to_send;
unsigned char data_received;

U16 speed;
U16 current;
U8  direction;

volatile uint8_t hall;

//! Set_cpu_prescaler
//!
//! ̊֐CPUOuڼ޽ɒ`ꂽl܂B
//!
//! @param U8	ׂOul
//!
//! @return		Ȃ
//!
#ifndef __GNUC__
  #pragma optimize=none 
  void Set_cpu_prescaler(U8 x)
  {
	U8 save_int=SREG&0x80;
	Disable_interrupt();
	CLKPR=(1<<CLKPCE);
	CLKPR=x;
	if(save_int) { Enable_interrupt(); }
  }
#endif

void main(void)
{
  Clear_prescaler();
  PLLInit();
  PWMInit();
  HallSensorInit();

  ADCInit();

  is_data_to_send=FALSE;							// USI޼ϐ
  is_data_received=FALSE;

  SpeedMeasure=0;
  is_speed_to_read=FALSE;

  Timer0Init();										// xp/0

  PortsInit();

  ushell_task_init();								// uShell

  Commutate();										// ̂ۏ؂邽߂ɈxCommutate()𑖍s

  Enable_interrupt();								// 荞݋BcA/Dϊݕω̊荞݂ɂĒ܂B

  for (;;) {
	if(ControlMode==MOTOR_CONTROL_CENTER)
	{
	  if (mcFastFlags.state == STATE_RUN)
	  {
		MotorSetDutyCycle(mcFastFlags.speed);		// d@xXV
		if(is_speed_to_read==TRUE)					// xJn
		  SpeedMeasurement();
	  }
	  else
	  {
		MotorSetDutyCycle(0);						// d@~
		mcFastFlags.speed=0;
	  }
	  ushell_task();								// Vd@߂𕜍

	  // VTWIMްǗ
	  if(is_data_received==FALSE)
	  {
		if (USI_TWI_Data_In_Receive_Buffer())		// USI̐V ?
		{
		  data_received=USI_TWI_Receive_Byte();
		  is_data_received=TRUE;
		}
	  }
	}
  }
}

void Commutate(void)
{
  uint8_t temp;
  // ΰيm͓ǂݍ
  temp = ( PINA & ((1 << PA5) | (1 << PA4) | (1 << PA1)) );
  hall = (((temp&0x30)>>3) | (temp&0x02)>>1);

  // ݂̕ƈʒuɏ]o͗l
  if (mcFastFlags.direction == DIRECTION_FORWARD) {
	TCCR1E = commTableForward[hall];
  }
  else {
	TCCR1E = commTableReverse[hall];
  }
}

#pragma inline=forced
void SpeedMeasurement(void)
{
//  if (timer_value == 0) 
//	{timer_value += 1 ;}	// 0Zx
/*
  new_measured_speed = K_SPEED / timer_value;
  if(new_measured_speed > 255) new_measured_speed = 255;	// ϐOa
  SpeedMeasure=(U16)new_measured_speed;
*/
  is_speed_to_read=FALSE;
}

void PLLInit(void)
{
  // Ӹۯ(/1p64MHz)
  PLLCSR = (1 << PCKE);
}

void PWMInit(void)
{
  TCCR1A = (1 << COM1A1) | (0 << COM1A0) | (1 << PWM1A);	// ㏸vŉ(0)w
  TCCR1D = (1 << WGM11) | (1 << WGM10);						// PWM6A2dXΌ`Ԃɐݒ
  TC1_WRITE_10_BIT_REGISTER(OCR1C, PWM_TOP_VALUE);			// (TOP)lݒ
  TCCR1B = (1 << CS10);										// S/1sJn
}

void HallSensorInit(void)
{
  PCMSK0 = (1 << PCINT1) | (1 << PCINT4) | (1 << PCINT5);	// PA1,4,5(PCINT1,4,5)ݕω荞݋
  PCMSK1 = 1;												// ꂪ0lɏ邽߁APCMSK10o (?)
  GIMSK |= (1 << PCIE1);									// ݕω荞1Q
}

void ADCInit(void)
{
  ADMUX = (0 << REFS1) | (0 << REFS0) |		// dƂVCC
		  (0 << ADLAR) |					// ʉE
		  ADMUX_PA2;						// ADC (MC301B)

  ADCSRB = (1 << REFS2) |					// (dIŏޯ)
		   ADC_TS_FREERUNNING;				// Aϊ

  ADCSRA = (1 << ADEN) |					// A/Dϊ틖
		   (1 << ADSC) |					// ϊJn()
		   (1 << ADATE) |					// N
		   (1 << ADIE) |					// A/Dϊ荞݋
		   ADC_PRESCALER;
}

void PortsInit(void)
{
  // PWM݂o͂ƂĐݒ(PWMo͖͂TCCR1Eڼ޽ʂĐ䂳܂B)
  DDRB = (1 << PB0) | (1 << PB1) | (1 << PB2) | (1 << PB3) | (1 << PB4) | (1 << PB5)| (1 << PB6) ;
}

void TWInit(void)
{
  USIPP|=(1<<USIPOS);								// USI߰ĂƂ߰AI
  USI_TWI_Slave_Initialise( TWI_SLAVE_ADDRESS ); 	// gTWI]uڽ
}

void MotorSetDutyCycle(U16 duty)
{
  TC1_WRITE_10_BIT_REGISTER(OCR1A, duty);
}

#ifdef __GNUC__
  ISR(PCINT_vect)
#else
#pragma vector = PCINT0_vect
__interrupt void HallChangeISR()
#endif
{
  Commutate();

  // ΰ1(U)̗オ[őx
  if (PINA&(1<<PORTA1))
  {
	if(is_speed_to_read==FALSE)
	{
	  TCCR0B &= ~((1<<CS02)|(1<<CS01) |(1<<CS00));		// /0~
	  TC0_READ_TCNT0(timer_value);						// /0l擾
	}
	TCCR0B = ((1<<CS02)|(0<<CS01) |(1<<CS00));			// /0ĊJ(128:16s)
	TC0_WRITE_TCNT0(0x0);
	is_speed_to_read=FALSE;								// 1ҋ@w
  }
  else
  {
	is_speed_to_read=TRUE;
  }
}

#ifdef __GNUC__
  ISR(ADC_vect)
#else
#pragma vector = ADC_vect
__interrupt void ADCISR()
#endif
{
  U16 speedSetpoint;

  speedSetpoint = ADC;					// A/Dϊ̎l擾

  if(speedSetpoint>=ADC_TWI)
  {
	ControlMode=MOTOR_CONTROL_CENTER;
	ADCSRA &= ~(1 << ADEN);				// A/Dϊ֎~
	ADCSRA &= ~(1 << ADIE);				// A/Dϊ荞݋֎~
	TWInit();
  }
  else
  {
	ControlMode=POTENTIOMETER;
	// o
	if (speedSetpoint >= ((ADC_MAX + 1) / 2)) {
	  mcFastFlags.direction = DIRECTION_FORWARD;
	  speedSetpoint -= ((ADC_MAX + 1) / 2);
	}
	else {
	  mcFastFlags.direction = DIRECTION_REVERSE;
	  speedSetpoint = ((ADC_MAX) / 2) - speedSetpoint;
	}
	// SPWM͈͂𓾂邽߂ɑxݒ_2{
	speedSetpoint *= 2;

	MotorSetDutyCycle(speedSetpoint);
  }
}

void Timer0Init(void)
{
  TCCR0B = ((1<<CS02)|(0<<CS01) |(1<<CS00));	// /0ĊJ(128:16s)
  TIFR |= (1<<TOV0);							// /0ꊄ荞ݗv׸މ(0)
  TC0_WRITE_TCNT0(0x0);
  TIMSK |= (1<<TOIE0);							// /0ꊄ荞݋
}

/**
  * @brief	xp/0
  * @pre	/0̌`Ԑݒ
  * @post	d@xŉ鎞Ɉꊄ荞݂𐶐
*/
#ifdef __GNUC__
  ISR(TIMER0_OVF_vect)
#else
#pragma vector = TIM0_OVF_vect
__interrupt void ovfl_timer0(void)
#endif
{
  TC0_WRITE_TCNT0(0x0);
  TIFR |= (1<<TOV0);							// /0ꊄ荞ݗv׸މ(0)
  TIMSK |= (1<<TOIE0);							// /0ꊄ荞݋
}
